using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Xml;
using System.IO;

namespace FeedHandlerLib
{
    public class RSSFeedGenerator
    {
        public static string GetRSS()
        {
            MemoryStream ms = new MemoryStream();
            XmlTextWriter writer = new XmlTextWriter(ms, null);
            SqlConnection cnn = new SqlConnection(ConfigurationManager.ConnectionStrings["connstr"].ConnectionString);
            SqlCommand cmd = new SqlCommand("select * from articles order by pubdate desc", cnn);
            cnn.Open();
            SqlDataReader reader = cmd.ExecuteReader();
            writer.WriteStartElement("rss");
            writer.WriteAttributeString("version", "2.0");
            writer.WriteStartElement("channel");
            writer.WriteElementString("title", "MyWebSite.com");
            writer.WriteElementString("link", "http://mywebsite.com");
            writer.WriteElementString("description", "Cool articles...");
            writer.WriteElementString("copyright", "Copyright (C) 2006");
            writer.WriteElementString("generator", "DotNetBips.com RSS Generator");
            while (reader.Read())
            {
                writer.WriteStartElement("item");
                writer.WriteElementString("title", reader.GetString(reader.GetOrdinal("title")));
                writer.WriteElementString("link", reader.GetString(reader.GetOrdinal("url")));
                writer.WriteElementString("description", reader.GetString(reader.GetOrdinal("description")));
                writer.WriteElementString("pubDate", reader.GetDateTime(reader.GetOrdinal("pubdate")).ToString(@"ddd, dd MMM yyyy 12:00:00 tt G\MT"));
                writer.WriteEndElement();
            }
            writer.WriteEndElement();
            writer.WriteEndElement();
            reader.Close();
            cnn.Close();
            writer.BaseStream.Flush();
            writer.Flush();
            ms.Flush();
            byte[] data = new byte[ms.Length];
            ms.Seek(0, SeekOrigin.Begin);
            ms.Read(data, 0, data.Length);
            ms.Close();
            return ASCIIEncoding.ASCII.GetString(data);
        }

    }
}
